<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>Chapitre 5. Autres fichiers dans le répertoire debian</title>
    <link rel="stylesheet" type="text/css" href="debian.css"/>
    <meta name="generator" content="DocBook XSL Stylesheets V1.78.1"/>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <link rel="home" href="index.fr.html" title="Guide du nouveau responsable Debian"/>
    <link rel="up" href="index.fr.html" title="Guide du nouveau responsable Debian"/>
    <link rel="prev" href="dreq.fr.html" title="Chapitre 4. Fichiers nécessaires dans le répertoire debian"/>
    <link rel="next" href="build.fr.html" title="Chapitre 6. Construction du paquet"/>
  </head>
  <body>
    <div class="navheader">
      <table width="100%" summary="Navigation header">
        <tr>
          <th colspan="3" align="center">Chapitre 5. Autres fichiers dans le répertoire <code class="filename">debian</code></th>
        </tr>
        <tr>
          <td align="left"><a accesskey="p" href="dreq.fr.html"><img src="images/prev.png" alt="Précédent"/></a> </td>
          <th width="60%" align="center"> </th>
          <td align="right"> <a accesskey="n" href="build.fr.html"><img src="images/next.png" alt="Suivant"/></a></td>
        </tr>
      </table>
      <hr/>
    </div>
    <div class="chapter">
      <div class="titlepage">
        <div>
          <div>
            <h1 class="title"><a id="dother"/>Chapitre 5. Autres fichiers dans le répertoire <code class="filename">debian</code></h1>
          </div>
        </div>
      </div>
      <div class="toc">
        <p>
          <strong>Table des matières</strong>
        </p>
        <dl class="toc">
          <dt>
            <span class="section">
              <a href="dother.fr.html#readme">5.1. <code class="filename">README.Debian</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#compat">5.2. <code class="filename">compat</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#conffiles">5.3. <code class="filename">conffiles</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#crond">5.4. <code class="filename"><em class="replaceable"><code>paquet</code></em>.cron.*</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#dirs">5.5. <code class="filename">dirs</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#doc-base">5.6. <code class="filename"><em class="replaceable"><code>paquet</code></em>.doc-base</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#docs">5.7. <code class="filename">docs</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#emacsen">5.8. <code class="filename">emacsen-*</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#examples">5.9. <code class="filename"><em class="replaceable"><code>paquet</code></em>.examples</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#initd">5.10. <code class="filename"><em class="replaceable"><code>paquet</code></em>.init</code> et
<code class="filename"><em class="replaceable"><code>paquet</code></em>.default</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#install">5.11. <code class="filename">install</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#info">5.12. <code class="filename"><em class="replaceable"><code>paquet</code></em>.info</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#links">5.13. <code class="filename"><em class="replaceable"><code>paquet</code></em>.links</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#lintian">5.14. <code class="filename">{<em class="replaceable"><code>paquet</code></em>.,source/}lintian-overrides</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#manpage">5.15. <code class="filename">manpage.*</code></a>
            </span>
          </dt>
          <dd>
            <dl>
              <dt>
                <span class="section">
                  <a href="dother.fr.html#manpage1">5.15.1. <code class="filename">manpage.1.ex</code></a>
                </span>
              </dt>
              <dt>
                <span class="section">
                  <a href="dother.fr.html#manpagesgml">5.15.2. <code class="filename">manpage.sgml.ex</code></a>
                </span>
              </dt>
              <dt>
                <span class="section">
                  <a href="dother.fr.html#manpagexml">5.15.3. <code class="filename">manpage.xml.ex</code></a>
                </span>
              </dt>
            </dl>
          </dd>
          <dt>
            <span class="section">
              <a href="dother.fr.html#manpages">5.16. <code class="filename"><em class="replaceable"><code>paquet</code></em>.manpages</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#menu">5.17. <code class="filename">menu</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#news">5.18. <code class="filename">NEWS</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#maintscripts">5.19. <code class="filename">{post,pre}{inst,rm}</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#symbols">5.20. <code class="filename"><em class="replaceable"><code>paquet</code></em>.symbols</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#todo">5.21. <code class="filename">TODO</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#watch">5.22. <code class="filename">watch</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#sourcef">5.23. <code class="filename">source/format</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#sourcel">5.24. <code class="filename">source/local-options</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#sourceopt">5.25. <code class="filename">source/options</code></a>
            </span>
          </dt>
          <dt>
            <span class="section">
              <a href="dother.fr.html#patches">5.26. <code class="filename">patches/*</code></a>
            </span>
          </dt>
        </dl>
      </div>
      <p>
Pour contrôler la plupart des actions de <code class="systemitem">debhelper</code> lors de la construction du paquet,
placez des fichiers de configuration optionnels dans le répertoire
<code class="filename">debian</code>. Ce chapitre présentera globalement le rôle de
ces fichiers et leur format. Veuillez consulter la <a class="ulink" href="http://www.debian.org/doc/devel-manuals#policy">Charte Debian</a> et la <a class="ulink" href="http://www.debian.org/doc/devel-manuals#devref">référence du développeur Debian</a> pour
les principes d'empaquetage.
</p>
      <p>
La commande <span class="command"><strong>dh_make</strong></span> crée quelques modèles de fichiers de
configuration dans le répertoire <code class="filename">debian</code>. La plupart
d'entre eux ont une extension <code class="literal">.ex</code>. Certains d'entre eux
ont le nom du paquet binaire comme préfixe :
<code class="literal"><em class="replaceable"><code>paquet</code></em></code>. Regardez-les
tous. <a href="#ftn.idp39241648" class="footnote" id="idp39241648"><sup class="footnote">[54]</sup></a>
</p>
      <p>
Certains modèles de fichiers de configuration de <code class="systemitem">debhelper</code> risquent de ne pas être créés par la
commande <span class="command"><strong>dh_make</strong></span>. Dans ce cas, vous devez les créer avec
un éditeur.
</p>
      <p>
Pour activer certains d'entre eux, veuillez suivre les instructions
suivantes :
</p>
      <div class="itemizedlist">
        <ul class="itemizedlist">
          <li class="listitem">
            <p>
renommer les fichiers modèles en enlevant l'extension <code class="literal">.ex</code>
ou <code class="literal">.EX</code> si elle existe ;
</p>
          </li>
          <li class="listitem">
            <p>
renommer les fichiers de configuration pour utiliser le véritable nom du
paquet binaire à la place de
<code class="literal"><em class="replaceable"><code>paquet</code></em></code> ;
</p>
          </li>
          <li class="listitem">
            <p>
modifiez le contenu des fichiers modèles selon vos besoins ;
</p>
          </li>
          <li class="listitem">
            <p>
enlevez les fichiers modèles dont vous n'avez pas besoin ;
</p>
          </li>
          <li class="listitem">
            <p>
si nécessaire, modifiez le fichier <code class="filename">control</code> (consultez
<a class="xref" href="dreq.fr.html#control" title="4.1. control">Section 4.1, « <code class="filename">control</code> »</a>) ;
</p>
          </li>
          <li class="listitem">
            <p>
si nécessaire, modifiez le fichier <code class="filename">rules</code> (consultez
<a class="xref" href="dreq.fr.html#rules" title="4.4. rules">Section 4.4, « <code class="filename">rules</code> »</a>).
</p>
          </li>
        </ul>
      </div>
      <p>
Les fichiers de configuration de <code class="systemitem">debhelper</code> sans préfixe
<code class="filename"><em class="replaceable"><code>paquet</code></em></code> comme
<code class="filename">install</code> sont relatifs au premier paquet
binaire. Lorsqu'il y a plusieurs paquets binaires, leur configuration
respective peut être précisée en ajoutant leur nom en préfixe du nom de
fichier de configuration :
<code class="filename"><em class="replaceable"><code>paquet-1</code></em>.install</code>,
<code class="filename"><em class="replaceable"><code>paquet-2</code></em>.install</code>, etc.
</p>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="readme"/>5.1. <code class="filename">README.Debian</code></h2>
            </div>
          </div>
        </div>
        <p>
Tous les détails ou différences entre le paquet original et votre version
Debian devraient être documentés ici.
</p>
        <p>
<span class="command"><strong>dh_make</strong></span> en crée un par défaut, qui ressemble à ceci :
</p>
        <pre class="screen">
gentoo for Debian
-----------------
&lt;possible notes regarding this package - if none, delete this file&gt;
 -- Josip Rodin &lt;joy-mg@debian.org&gt;, Wed, 11 Nov 1998 21:02:14 +0100
</pre>
        <p>
Si vous n'avez rien à documenter, effacez ce fichier, consultez
<span class="citerefentry"><span class="refentrytitle">dh_installdocs</span>(1)</span>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="compat"/>5.2. <code class="filename">compat</code></h2>
            </div>
          </div>
        </div>
        <p>
Le fichier <code class="filename">compat</code> définit le niveau de compatibilité de
<code class="systemitem">debhelper</code>. Actuellement, vous
devriez le définir à <code class="systemitem">debhelper</code> v9
comme suit :
</p>
        <pre class="screen">
$ echo 9 &gt; debian/compat
</pre>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="conffiles"/>5.3. <code class="filename">conffiles</code></h2>
            </div>
          </div>
        </div>
        <p>
Une des choses les plus irritantes à propos des logiciels est de consacrer
beaucoup de temps et d'efforts pour configurer un programme, et de voir une
seule mise à jour détruire tous ses changements. Debian résout ce problème
en marquant ces fichiers de configuration comme des conffiles. <a href="#ftn.idp39269840" class="footnote" id="idp39269840"><sup class="footnote">[55]</sup></a> Lors de la mise à jour d'un paquet, une question
sera posée, permettant de garder les anciens fichiers de configuration ou
non.
</p>
        <p>
<span class="citerefentry"><span class="refentrytitle">dh_installdeb</span>(1)</span> considère
<span class="emphasis"><em>automatiquement</em></span> tous les fichiers du répertoire
<code class="filename">/etc</code> comme des conffiles, donc si tous les fichiers de
configuration de votre programme sont dans ce répertoire, il n'est pas
nécessaire de les indiquer dans ce fichier. Pour la plupart des paquets, le
seul endroit devant contenir des conffiles est <code class="filename">/etc</code>,
donc ce fichier ne devrait pas exister.
</p>
        <p>
Si votre programme utilise des fichiers de configuration, mais les réécrit
aussi de son côté, il vaut mieux ne pas les marquer comme conffiles, parce
que <span class="command"><strong>dpkg</strong></span> va alors interroger les utilisateurs pour
vérifier les modifications tout le temps.
</p>
        <p>
Si le programme que vous empaquetez force tous les utilisateurs à modifier
les fichiers de configuration du répertoire <code class="filename">/etc</code>, il y
a deux façons classiques de ne pas les marquer comme conffiles, et garder
<span class="command"><strong>dpkg</strong></span> silencieux :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
créer un lien symbolique dans le répertoire <code class="filename">/etc</code> vers
un fichier du répertoire <code class="filename">/var</code> créé par les scripts du
responsable ;
</p>
            </li>
            <li class="listitem">
              <p>
créer un fichier généré par les scripts du responsable dans le répertoire
<code class="filename">/etc</code>.
</p>
            </li>
          </ul>
        </div>
        <p>
Pour obtenir des renseignements sur les scripts du responsable, consultez
<a class="xref" href="dother.fr.html#maintscripts" title="5.19. {post,pre}{inst,rm}">Section 5.19, « <code class="filename">{post,pre}{inst,rm}</code> »</a>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="crond"/>5.4. <code class="filename"><em class="replaceable"><code>paquet</code></em>.cron.*</code></h2>
            </div>
          </div>
        </div>
        <p>
Si le paquet a besoin d'exécuter des tâches régulièrement pour fonctionner
correctement, vous pouvez utiliser ces fichiers pour les configurer. Vous
pouvez programmer des tâches régulières horaires, quotidiennes, mensuelles
ou qui se produiront au moment que vous préférez. Les noms de fichiers
sont :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
<code class="filename"><em class="replaceable"><code>paquet</code></em>.cron.hourly</code> —
installé comme
<code class="filename">/etc/cron.hourly/<em class="replaceable"><code>paquet</code></em></code> et
exécuté une fois par heure ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="filename"><em class="replaceable"><code>paquet</code></em>.cron.daily</code> — installé
comme
<code class="filename">/etc/cron.daily/<em class="replaceable"><code>paquet</code></em></code> et
exécuté une fois par jour ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="filename"><em class="replaceable"><code>paquet</code></em>.cron.weekly</code> —
installé comme
<code class="filename">/etc/cron.weekly/<em class="replaceable"><code>paquet</code></em></code> et
exécuté une fois par semaine ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="filename"><em class="replaceable"><code>paquet</code></em>.cron.monthly</code> —
installé comme
<code class="filename">/etc/cron.monthly/<em class="replaceable"><code>paquet</code></em></code> et
exécuté une fois par mois ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="filename"><em class="replaceable"><code>paquet</code></em>.cron.d</code> — installé
comme <code class="filename">/etc/cron.d/<em class="replaceable"><code>paquet</code></em></code> et
exécuté à tout autre moment.
</p>
            </li>
          </ul>
        </div>
        <p>
La plupart de ces fichiers sont des scripts shell, à l'exception de
<code class="filename"><em class="replaceable"><code>paquet</code></em>.cron.d</code> dont le format
est celui de <span class="citerefentry"><span class="refentrytitle">crontab</span>(5)</span>.
</p>
        <p>
Aucun fichier <code class="filename">cron.*</code> n'est nécessaire pour configurer
la rotation des journaux ; pour cela, voyez <span class="citerefentry"><span class="refentrytitle">dh_installlogrotate</span>(1)</span> et <span class="citerefentry"><span class="refentrytitle">logrotate</span>(8)</span>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="dirs"/>5.5. <code class="filename">dirs</code></h2>
            </div>
          </div>
        </div>
        <p>
Ce fichier indique les répertoires nécessaires mais qui ne sont pas créés
par la procédure d'installation normale (<code class="literal">make install
DESTDIR=...</code> invoquée par
<code class="literal">dh_auto_install</code>). C'est souvent dû à un problème avec le
<code class="filename">Makefile</code>.
</p>
        <p>
Les fichiers énumérés dans un fichier <code class="filename">install</code> n'ont pas
besoin que leurs répertoires soient créés avant, consultez <a class="xref" href="dother.fr.html#install" title="5.11. install">Section 5.11, « <code class="filename">install</code> »</a>.
</p>
        <p>
Il est préférable d'essayer d'exécuter l'installation, et d'utiliser
seulement ce recours si vous avez des problèmes. Il n'y a pas de barre
oblique (<code class="literal">/</code>) au début des noms de répertoire dans la liste
du fichier <code class="filename">dirs</code>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="doc-base"/>5.6. <code class="filename"><em class="replaceable"><code>paquet</code></em>.doc-base</code></h2>
            </div>
          </div>
        </div>
        <p>
Si votre paquet est fournit avec une autre documentation que des pages de
manuel et d'information, vous devriez utiliser le fichier <code class="systemitem">doc-base</code> pour l'enregistrer, de sorte que
l'utilisateur puisse la trouver avec par exemple <span class="citerefentry"><span class="refentrytitle">dhelp</span>(1)</span>, <span class="citerefentry"><span class="refentrytitle">dwww</span>(1)</span> ou <span class="citerefentry"><span class="refentrytitle">doccentral</span>(1)</span>.
</p>
        <p>
Cela inclut normalement les fichiers HTML, PS et PDF, inclus dans
<code class="filename">/usr/share/doc/<em class="replaceable"><code>nomdepaquet</code></em>/</code>.
</p>
        <p>
Voici ce à quoi le fichier <code class="filename">gentoo.doc-base</code> de
<code class="systemitem">gentoo</code> ressemble :
</p>
        <pre class="screen">
Document: gentoo
Title: Gentoo Manual
Author: Emil Brink
Abstract: This manual describes what Gentoo is, and how it can be used.
Section: File Management
Format: HTML
Index: /usr/share/doc/gentoo/html/index.html
Files: /usr/share/doc/gentoo/html/*.html
</pre>
        <p>
Pour obtenir plus de renseignements sur le format de ce fichier, consultez
<span class="citerefentry"><span class="refentrytitle">install-docs</span>(8)</span> et la copie locale
<code class="filename">/usr/share/doc/doc-base/doc-base.html/index.html</code> du manuel Debian de <code class="systemitem">doc-base</code>.
</p>
        <p>
Pour obtenir plus de renseignements sur l'installation de documentation
supplémentaire, consultez <a class="xref" href="modify.fr.html#destdir" title="3.3. Installation des fichiers à leur emplacement">Section 3.3, « Installation des fichiers à leur emplacement »</a>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="docs"/>5.7. <code class="filename">docs</code></h2>
            </div>
          </div>
        </div>
        <p>
Ce fichier spécifie les noms des fichiers de documentation que
<span class="citerefentry"><span class="refentrytitle">dh_installdocs</span>(1)</span> peut installer pour vous dans le
répertoire temporaire.
</p>
        <p>
Par défaut, il inclut tous les fichiers, existant dans le répertoire racine
des sources, qui sont nommés <code class="filename">BUGS</code>,
<code class="filename">README*</code>, <code class="filename">TODO</code>, etc.
</p>
        <p>
Pour <code class="systemitem">gentoo</code>, d'autres fichiers sont
aussi inclus :
</p>
        <pre class="screen">
BUGS
CONFIG-CHANGES
CREDITS
NEWS
README
README.gtkrc
TODO
</pre>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="emacsen"/>5.8. <code class="filename">emacsen-*</code></h2>
            </div>
          </div>
        </div>
        <p>
Si votre paquet fournit des fichiers Emacs qui peuvent être byte-compilés au
moment de l'installation, vous pouvez utiliser ces fichiers pour les
configurer.
</p>
        <p>
Ils sont installés dans le répertoire temporaire par <span class="citerefentry"><span class="refentrytitle">dh_installemacsen</span>(1)</span>.
</p>
        <p>
Si vous n'en avez pas besoin, effacez-les.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="examples"/>5.9. <code class="filename"><em class="replaceable"><code>paquet</code></em>.examples</code></h2>
            </div>
          </div>
        </div>
        <p>
La commande <span class="citerefentry"><span class="refentrytitle">dh_installexamples</span>(1)</span> installe les fichiers et
répertoires énumérés ici comme des fichiers d'exemple.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="initd"/>5.10. <code class="filename"><em class="replaceable"><code>paquet</code></em>.init</code> et
<code class="filename"><em class="replaceable"><code>paquet</code></em>.default</code></h2>
            </div>
          </div>
        </div>
        <p>
Si votre paquet est un démon qui doit être exécuté au démarrage du système,
vous avez de toute évidence ignoré les recommandations initiales,
n'est-ce-pas ? :-)
</p>
        <p>
Le fichier <code class="filename"><em class="replaceable"><code>paquet</code></em>.init</code> est
installé comme un script qui sert à démarrer et arrêter le démon en
<code class="filename">/etc/init.d/<em class="replaceable"><code>paquet</code></em></code>. Un
squelette de modèle générique est fournit par la commande
<span class="command"><strong>dh_make</strong></span> en <code class="filename">init.d.ex</code>. Vous devrez
sans doute le renommer et le modifier, beaucoup, en vous assurant que les
en-têtes respectent la <a class="ulink" href="http://www.linuxfoundation.org/collaborate/workgroups/lsb">Linux Standard Base</a>
(LSB). Il est installé dans le répertoire temporaire par <span class="citerefentry"><span class="refentrytitle">dh_installinit</span>(1)</span>.
</p>
        <p>
Le fichier <code class="filename"><em class="replaceable"><code>paquet</code></em>.default</code>
est installé en tant que
<code class="filename">/etc/default/<em class="replaceable"><code>paquet</code></em></code>. Ce
fichier définit les valeurs par défaut des variables utilisées par le script
d'initialisation. Ce fichier est le plus souvent utilisé pour désactiver le
démarrage d'un démon ou pour paramétrer quelques options ou temps
limites. Si le script d'initialisation contient certaines fonctionnalités
<span class="emphasis"><em>paramétrables</em></span>, elles ont leur place dans ce fichier
<code class="filename"><em class="replaceable"><code>paquet</code></em>.default</code> au lieu du
script d'initialisation lui-même.
</p>
        <p>
Si le programme amont fournit un fichier pour le script d'initialisation,
vous avez le choix de l'utiliser ou non. Si vous n'utilisez pas leur script
d'initialisation, créez-en un nouveau en
<code class="filename"><em class="replaceable"><code>paquet</code></em>.init</code>. Cependant, si
le script d'initialisation amont semble fonctionnel et s'installe au bon
endroit, il vous faudra tout de même configurer le lien symbolique
<code class="filename">rc*</code>. Pour cela, il faut remplacer
<span class="command"><strong>dh_installinit</strong></span> dans le fichier <code class="filename">rules</code>
avec les lignes suivantes :
</p>
        <pre class="screen">
override_dh_installinit:
        dh_installinit --onlyscripts
</pre>
        <p>
Si vous n'en avez pas besoin, effacez ces fichiers.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="install"/>5.11. <code class="filename">install</code></h2>
            </div>
          </div>
        </div>
        <p>
Si des fichiers doivent être installés dans le paquet mais que <code class="literal">make
install</code> normal ne le fait pas, il faut ajouter les noms de
fichiers et leur destination dans ce fichier
<code class="filename">install</code>. Ils sont installés par <span class="citerefentry"><span class="refentrytitle">dh_install</span>(1)</span>.<a href="#ftn.idp39357968" class="footnote" id="idp39357968"><sup class="footnote">[56]</sup></a> Vous devriez d'abord
vérifier s'il n'y a pas un outil plus approprié à utiliser. Par exemple, les
documents devraient être dans le fichier <code class="filename">docs</code> et non
dans celui-ci.
</p>
        <p>
Ce fichier <code class="filename">install</code> possède une ligne par fichier
installé, avec le nom du fichier (par rapport au répertoire de construction
principal) suivi d'un espace puis du répertoire d'installation (par rapport
au répertoire d'installation). Par exemple, si un binaire
<code class="filename">src/<em class="replaceable"><code>truc</code></em></code> n'est pas installé,
le fichier <code class="filename">install</code> pourrait ressembler à :
</p>
        <pre class="screen">
src/<em class="replaceable"><code>truc</code></em> usr/bin
</pre>
        <p>
Cela signifie que lors de l'installation du paquet, il y aura une commande
exécutable <code class="filename">/usr/bin/<em class="replaceable"><code>truc</code></em></code>.
</p>
        <p>
Ce fichier <code class="filename">install</code> peut renseigner seulement le nom du
fichier sans le répertoire d'installation quand le chemin relatif n'est pas
modifié. Ce format est normalement utilisé pour un gros paquet qui découpe
le résultat de la construction en plusieurs paquets binaires à l'aide de
<code class="filename"><em class="replaceable"><code>paquet-1</code></em>.install</code>,
<code class="filename"><em class="replaceable"><code>paquet-2</code></em>.install</code>, etc.
</p>
        <p>
La commande <span class="command"><strong>dh_install</strong></span> finira par chercher les fichiers
dans <code class="filename">debian/tmp</code>, s'il ne les trouve pas dans le
répertoire courant (ou quelque soit l'endroit où il lui a été demandé de
chercher avec <code class="literal">--sourcedir</code>).
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="info"/>5.12. <code class="filename"><em class="replaceable"><code>paquet</code></em>.info</code></h2>
            </div>
          </div>
        </div>
        <p>
Si le paquet possède des pages d'information, vous devriez les installer
avec <span class="citerefentry"><span class="refentrytitle">dh_installinfo</span>(1)</span> en les énumérant dans un fichier
<code class="filename"><em class="replaceable"><code>paquet</code></em>.info</code>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="links"/>5.13. <code class="filename"><em class="replaceable"><code>paquet</code></em>.links</code></h2>
            </div>
          </div>
        </div>
        <p>
Pour créer des liens symboliques supplémentaires dans les répertoires de
construction du paquet en tant que responsable du paquet, vous devriez les
installer avec <span class="citerefentry"><span class="refentrytitle">dh_link</span>(1)</span> en énumérant leurs chemins complets
de fichiers source et destination dans un fichier
<code class="filename"><em class="replaceable"><code>paquet</code></em>.links</code>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="lintian"/>5.14. <code class="filename">{<em class="replaceable"><code>paquet</code></em>.,source/}lintian-overrides</code></h2>
            </div>
          </div>
        </div>
        <p>
Si <code class="systemitem">lintian</code> signale des erreurs dans
son diagnostic alors que la Charte accepte des exceptions à certaines
règles, vous pouvez utiliser
<code class="filename"><em class="replaceable"><code>paquet</code></em>.lintian-overrides</code> ou
<code class="filename">source/lintian-overrides</code> pour le rendre
silencieux. Veuillez lire le manuel utilisateur de Lintian
(<code class="filename">/usr/share/doc/lintian/lintian.html/index.html</code>) et vous abstenir d'en abuser.
</p>
        <p>
<code class="filename"><em class="replaceable"><code>paquet</code></em>.lintian-overrides</code>
concerne le paquet binaire appelé <code class="systemitem"><em class="replaceable"><code>paquet</code></em></code>, il est
installé en
<code class="filename">usr/share/lintian/overrides/<em class="replaceable"><code>paquet</code></em></code>
par la commande <span class="command"><strong>dh_lintian</strong></span>.
</p>
        <p>
<code class="filename">source/lintian-overrides</code> concerne le paquet source. Il
n'est pas installé.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="manpage"/>5.15. <code class="filename">manpage.*</code></h2>
            </div>
          </div>
        </div>
        <p>
Le programme devrait être livré avec une page de manuel. Sinon, vous devriez
en créer au moins une. La commande <span class="command"><strong>dh_make</strong></span> crée quelques
modèles de fichiers pour pages de manuel. Ils doivent être copiés et
modifiés pour chaque commande à laquelle il manque une page de
manuel. Veuillez vous assurer d'avoir effacé les modèles non utilisés.
</p>
        <div class="section">
          <div class="titlepage">
            <div>
              <div>
                <h3 class="title"><a id="manpage1"/>5.15.1. <code class="filename">manpage.1.ex</code></h3>
              </div>
            </div>
          </div>
          <p>
Les pages de manuel sont normalement écrites en <span class="citerefentry"><span class="refentrytitle">nroff</span>(1)</span>. L'exemple <code class="filename">manpage.1.ex</code> est aussi écrit
en <span class="command"><strong>nroff</strong></span>. Lisez la page de manuel <span class="citerefentry"><span class="refentrytitle">man</span>(7)</span>
pour une brève description sur la façon d'éditer ce genre de fichiers.
</p>
          <p>
Le nom de fichier de la page de manuel devrait donner le nom du programme
qu'elle documente, donc <code class="literal">manpage</code> doit être renommé en
<code class="literal">gentoo</code>. Le nom de fichier inclut aussi
<code class="literal">.1</code> comme premier suffixe, qui signifie que c'est une page
de manuel pour une commande utilisateur. Assurez-vous de vérifier que cette
section est effectivement la bonne. Voici une courte liste des sections de
pages de manuel :
</p>
          <div class="informaltable">
            <a id="manpage-sections"/>
            <table border="1">
              <colgroup>
                <col style="text-align: left"/>
                <col style="text-align: left"/>
                <col style="text-align: left"/>
              </colgroup>
              <thead>
                <tr>
                  <th style="text-align: left">Section</th>
                  <th style="text-align: left">Description</th>
                  <th style="text-align: left">Remarques</th>
                </tr>
              </thead>
              <tbody>
                <tr>
                  <td style="text-align: left">1</td>
                  <td style="text-align: left">Commandes utilisateur</td>
                  <td style="text-align: left">Commandes ou scripts exécutables</td>
                </tr>
                <tr>
                  <td style="text-align: left">2</td>
                  <td style="text-align: left">Appels système</td>
                  <td style="text-align: left">Fonctions fournies par le noyau</td>
                </tr>
                <tr>
                  <td style="text-align: left">3</td>
                  <td style="text-align: left">Appels de bibliothèque</td>
                  <td style="text-align: left">Fonctions des bibliothèques système</td>
                </tr>
                <tr>
                  <td style="text-align: left">4</td>
                  <td style="text-align: left">Fichiers spéciaux</td>
                  <td style="text-align: left">Situés généralement dans <code class="filename">/dev</code></td>
                </tr>
                <tr>
                  <td style="text-align: left">5</td>
                  <td style="text-align: left">Formats de fichier</td>
                  <td style="text-align: left">Par exemple le format de <code class="filename">/etc/passwd</code></td>
                </tr>
                <tr>
                  <td style="text-align: left">6</td>
                  <td style="text-align: left">Jeux</td>
                  <td style="text-align: left">Jeux ou autres programmes frivoles</td>
                </tr>
                <tr>
                  <td style="text-align: left">7</td>
                  <td style="text-align: left">Macropaquets</td>
                  <td style="text-align: left">Comme les macros de <span class="command"><strong>man</strong></span></td>
                </tr>
                <tr>
                  <td style="text-align: left">8</td>
                  <td style="text-align: left">Administration système</td>
                  <td style="text-align: left">Programmes normalement exécutés par le superutilisateur</td>
                </tr>
                <tr>
                  <td style="text-align: left">9</td>
                  <td style="text-align: left">Sous-programmes du noyau</td>
                  <td style="text-align: left">Appels non standards et routines internes</td>
                </tr>
              </tbody>
            </table>
          </div>
          <p>
Ainsi, la page de manuel de <code class="systemitem">gentoo</code>
devrait être appelée <code class="filename">gentoo.1</code>. S'il n'y avait pas de
page de manuel <code class="filename">gentoo.1</code> dans les sources originales, il
aurait fallu renommer le modèle <code class="filename">manpage.1.ex</code> en
<code class="filename">gentoo.1</code> puis le modifier à partir des informations de
l'exemple et de la documentation amont.
</p>
          <p>
La commande <span class="command"><strong>help2man</strong></span> peut aussi être utilisée pour créer
une page de manuel à partir de la sortie de <code class="literal">--help</code> et
<code class="literal">--version</code> pour chaque programme. <a href="#ftn.idp39425664" class="footnote" id="idp39425664"><sup class="footnote">[57]</sup></a>
</p>
        </div>
        <div class="section">
          <div class="titlepage">
            <div>
              <div>
                <h3 class="title"><a id="manpagesgml"/>5.15.2. <code class="filename">manpage.sgml.ex</code></h3>
              </div>
            </div>
          </div>
          <p>
D'un autre côté, si vous préférez écrire du SGML plutôt que du
<span class="command"><strong>nroff</strong></span>, vous pouvez utiliser le modèle
<code class="filename">manpage.sgml.ex</code>. Si vous le faites, vous devez :
</p>
          <div class="itemizedlist">
            <ul class="itemizedlist">
              <li class="listitem">
                <p>
renommer le fichier en quelque chose comme
<code class="filename">gentoo.sgml</code> ;
</p>
              </li>
              <li class="listitem">
                <p>
installer le paquet <code class="systemitem">docbook-to-man</code> ;
</p>
              </li>
              <li class="listitem">
                <p>
ajouter <code class="literal">docbook-to-man</code> à la ligne
<code class="literal">Build-Depends</code> dans le fichier
<code class="filename">control</code> ;
</p>
              </li>
              <li class="listitem">
                <p>
ajouter une cible <code class="literal">override_dh_auto_build</code> au fichier
<code class="filename">rules</code> :
</p>
                <pre class="screen">
override_dh_auto_build:
        docbook-to-man debian/gentoo.sgml &gt; debian/gentoo.1
        dh_auto_build
</pre>
              </li>
            </ul>
          </div>
        </div>
        <div class="section">
          <div class="titlepage">
            <div>
              <div>
                <h3 class="title"><a id="manpagexml"/>5.15.3. <code class="filename">manpage.xml.ex</code></h3>
              </div>
            </div>
          </div>
          <p>
Si vous préférez XML à SGML, vous pouvez utiliser le modèle
<code class="literal">manpage.xml.ex</code>. Si vous le faites, vous devez :
</p>
          <div class="itemizedlist">
            <ul class="itemizedlist">
              <li class="listitem">
                <p>
renommer le fichier en quelque chose comme <code class="literal">gentoo.xml</code> ;
</p>
              </li>
              <li class="listitem">
                <p>
installer le paquet <code class="systemitem">docbook-xsl</code> et
un processeur XSLT comme <code class="systemitem">xsltproc</code>
(recommandé) ;
</p>
              </li>
              <li class="listitem">
                <p>
ajouter <code class="literal">docbook-xsl</code>, <code class="literal">docbook-xml</code> et
<code class="literal">xsltproc</code> à la ligne <code class="literal">Build-Depends</code> dans
le fichier <code class="literal">control</code> ;
</p>
              </li>
              <li class="listitem">
                <p>
ajouter une cible <code class="literal">override_dh_auto_build</code> au fichier
<code class="filename">rules</code> :
</p>
                <pre class="screen">
override_dh_auto_build:
        xsltproc --nonet \
         --param make.year.ranges 1 \
         --param make.single.year.ranges 1 \
         --param man.charmap.use.subset 0 \
         -o debian/ \
 http://docbook.sourceforge.net/release/xsl/current/manpages/docbook.xsl\
        debian/gentoo.1.xml
        dh_auto_build
</pre>
              </li>
            </ul>
          </div>
        </div>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="manpages"/>5.16. <code class="filename"><em class="replaceable"><code>paquet</code></em>.manpages</code></h2>
            </div>
          </div>
        </div>
        <p>
Si le paquet possède des pages de manuel, vous devriez les installer avec
<span class="citerefentry"><span class="refentrytitle">dh_installman</span>(1)</span> en les énumérant dans un fichier
<code class="filename"><em class="replaceable"><code>paquet</code></em>.manpages</code>.
</p>
        <p>
Pour installer <code class="filename">docs/gentoo.1</code> en tant que page de manuel
du le paquet <code class="systemitem">gentoo</code>, créez le
fichier <code class="filename">gentoo.manpages</code> contenant :
</p>
        <pre class="screen">
docs/gentoo.1
</pre>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="menu"/>5.17. <code class="filename">menu</code></h2>
            </div>
          </div>
        </div>
        <p>
Les utilisateurs de X Window ont un gestionnaire de fenêtres avec un menu
qui peut être configuré pour lancer des programmes. S'ils ont installé le
paquet <code class="systemitem">menu</code> de Debian, un ensemble
de menus pour chaque programme sur le système sera créé pour eux.
</p>
        <p>
Voici le fichier <code class="filename">menu.ex</code> créé par défaut par
<span class="command"><strong>dh_make</strong></span> :
</p>
        <pre class="screen">
?package(gentoo):needs=X11|text|vc|wm \
        section=Applications/see-menu-manual\
        title=gentoo command=/usr/bin/gentoo
</pre>
        <p>
Le premier champ après les deux points est <code class="literal">needs</code>, il
indique le genre d'interface dont a besoin le programme. Changez ceci en une
des alternatives énumérées, par exemple <code class="literal">text</code> ou
<code class="literal">X11</code>.
</p>
        <p>
Le champ suivant est la <code class="literal">section</code> où l'entrée de menu et de
sous-menu devrait apparaître. <a href="#ftn.idp39463984" class="footnote" id="idp39463984"><sup class="footnote">[58]</sup></a>
</p>
        <p>
Le champ <code class="literal">title</code> est le nom du programme. Vous pouvez le
commencer par une majuscule si vous le souhaitez. Mais gardez-le court.
</p>
        <p>
Enfin, le champ <code class="literal">command</code> est la commande qui exécute le
programme.
</p>
        <p>
Une fois le fichier renommé en <code class="filename">menu</code>, l'entrée de menu
peut être modifiée comme ceci :
</p>
        <pre class="screen">
?package(gentoo): needs=X11 \
        section=Applications/Tools \
        title=Gentoo command=gentoo
</pre>
        <p>
Vous pouvez aussi ajouter d'autres champs comme
<code class="literal">longtitle</code>, <code class="literal">icon</code>,
<code class="literal">hints</code>, etc. Consultez <span class="citerefentry"><span class="refentrytitle">dh_installmenu</span>(1)</span>, <span class="citerefentry"><span class="refentrytitle">menufile</span>(5)</span>, <span class="citerefentry"><span class="refentrytitle">update-menus</span>(1)</span> et la <a class="ulink" href="http://www.debian.org/doc/packaging-manuals/menu-policy/">sous-charte de menu
Debian</a> pour obtenir plus de renseignements.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="news"/>5.18. <code class="filename">NEWS</code></h2>
            </div>
          </div>
        </div>
        <p>
La commande <span class="citerefentry"><span class="refentrytitle">dh_installchangelogs</span>(1)</span> l'installe.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="maintscripts"/>5.19. <code class="filename">{post,pre}{inst,rm}</code></h2>
            </div>
          </div>
        </div>
        <p>
Les fichiers <code class="filename">postinst</code>, <code class="filename">preinst</code>,
<code class="filename">postrm</code>, et <code class="filename">prerm</code> <a href="#ftn.idp39481568" class="footnote" id="idp39481568"><sup class="footnote">[59]</sup></a> sont nommés <span class="emphasis"><em>scripts du
responsable</em></span>. Ces scripts sont placés dans la zone de contrôle du
paquet et sont exécutés par <span class="command"><strong>dpkg</strong></span> lorsque le paquet est
installé, mis à jour ou supprimé.
</p>
        <p>
En tant que responsable débutant, vous devriez éviter de modifier
manuellement les scripts du responsable parce qu'ils ont tendance à être
complexes. Pour obtenir plus de renseignements, consultez dans la <a class="ulink" href="http://www.debian.org/doc/debian-policy/ch-maintainerscripts.html">Charte Debian, chapitre 6 « scripts du
responsable et procédure d'installation »</a> et examinez les fichiers
d'exemple fournis par <span class="command"><strong>dh_make</strong></span>.
</p>
        <p>
Si vous préférez n'en faire qu'à votre tête en personnalisant vos scripts du
responsable pour un paquet, vous devriez les essayer non seulement lors de
l'<span class="strong"><strong>installation</strong></span> et la <span class="strong"><strong>mise à jour</strong></span>, mais aussi pour la <span class="strong"><strong>désinstallation</strong></span> et la <span class="strong"><strong>purge</strong></span>.
</p>
        <p>
Les mises à jour devraient être silencieuses et non intrusives (les
utilisateurs existants ne devraient pas remarquer la mise à jour à part en
constatant la résolution de vieux bogues et peut-être l'arrivée de nouvelles
fonctionnalités).
</p>
        <p>
Lorsque la mise à niveau est forcément intrusive (par exemple des fichiers
de configuration dispersés dans plusieurs répertoires personnels avec des
structures complètement différentes), vous pouvez envisager en dernier
recours de basculer le paquet vers un état de repli sûr (par exemple en
désactivant un service) et en fournissant la documentation adéquate
conformément à la Charte Debian (<code class="filename">README.Debian</code> et
<code class="filename">NEWS.Debian</code>). N'embêtez pas l'utilisateur avec des
notes <span class="command"><strong>debconf</strong></span> déclenchées par les scripts du responsable
lors des mises à niveau.
</p>
        <p>
Le paquet <code class="systemitem">ucf</code> fournit un dispositif
<span class="emphasis"><em>à la conffile</em></span> pour conserver les modifications des
utilisateurs pour les fichiers qui n'ont pas été marqués comme
<span class="emphasis"><em>conffiles</em></span> comme ceux gérés par les scripts du
responsable. Cela permet de réduire les problèmes associés à ces fichiers.
</p>
        <p>
Ces scripts du responsable font partie des améliorations de Debian qui
expliquent <span class="strong"><strong>pourquoi les gens choisissent
Debian</strong></span>. Prenez garde de ne pas les transformer en source
d'agacement.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="symbols"/>5.20. <code class="filename"><em class="replaceable"><code>paquet</code></em>.symbols</code></h2>
            </div>
          </div>
        </div>
        <p>
L'empaquetage de bibliothèque n'est pas facile pour un mainteneur débutant,
et devrait être évité. Cela dit, si le paquet fournit des bibliothèques, des
fichiers
<code class="filename">debian/<em class="replaceable"><code>paquet</code></em>.symbols</code>
devraient exister. Consultez <a class="xref" href="advanced.fr.html#librarysymbols" title="A.2. Gestion de debian/paquet.symbols">Section A.2, « Gestion de
<code class="filename">debian/<em class="replaceable"><code>paquet</code></em>.symbols</code> »</a>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="todo"/>5.21. <code class="filename">TODO</code></h2>
            </div>
          </div>
        </div>
        <p>
La commande <span class="citerefentry"><span class="refentrytitle">dh_installdocs</span>(1)</span> l'installe.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="watch"/>5.22. <code class="filename">watch</code></h2>
            </div>
          </div>
        </div>
        <p>
Le format du fichier <code class="filename">watch</code> est documenté dans la page
de manuel <span class="citerefentry"><span class="refentrytitle">uscan</span>(1)</span>. Le fichier
<code class="filename">watch</code> configure le programme <span class="command"><strong>uscan</strong></span>
(dans le paquet <code class="systemitem">devscripts</code>) pour
surveiller le site sur lequel vous avez obtenu les sources. C'est également
utilisé par le service d'<a class="ulink" href="http://wiki.debian.org/DEHS">état de santé extérieur à
Debian ou « Debian External Health Status » (DEHS)</a>.
</p>
        <p>
Voici ce qu'il contient :
</p>
        <pre class="screen">
# watch control file for uscan
version=3
http://sf.net/gentoo/gentoo-(.+)\.tar\.gz debian uupdate
</pre>
        <p>
Normalement, avec un fichier <code class="filename">watch</code>, la page servie à
l'URL <code class="literal">http://sf.net/gentoo</code> est téléchargée pour chercher des
liens sous la forme <code class="literal">&lt;a href=...&gt;</code>. Le nom de base
(juste après la dernière <code class="literal">/</code>) de chaque URL liée est
comparé au motif de l'expression rationnelle Perl
<code class="literal">gentoo-(.+)\.tar\.gz</code> (consultez <span class="citerefentry"><span class="refentrytitle">perlre</span>(1)</span>). Parmi les fichiers correspondants, celui avec le plus
grand numéro de version est téléchargé puis le programme
<span class="command"><strong>uupdate</strong></span> est exécuté pour créer une arborescence source
mise à jour.
</p>
        <p>
Bien que ce soit vrai pour les autres sites, le service de téléchargement de
SourceForge en <a class="ulink" href="http://sf.net">http://sf.net</a> est une exception. Quand le fichier
<code class="filename">watch</code> comporte une URL correspondant au motif
d'expression rationnelle <code class="literal">^http://sf\.net/</code>, le programme
<span class="command"><strong>uscan</strong></span> le remplace par
<code class="literal">http://qa.debian.org/watch/sf.php/</code> et applique ensuite cette règle. Le
service de redirection en <a class="ulink" href="http://qa.debian.org/">http://qa.debian.org/</a> est conçu pour offrir un
service stable vers le fichier voulu pour les motifs
<code class="filename">watch</code> de la forme
<code class="literal">http://sf.net/<em class="replaceable"><code>projet</code></em>/<em class="replaceable"><code>nom-d-archive</code></em>-(.+)\.tar\.gz</code>.
Le but est de résoudre le problème lié au fréquent changement d'URL
SourceForge.
</p>
        <p>
Si la source propose une signature cryptographique pour l’archive, il est
recommandé de vérifier son authenticité en utilisant l’option
<code class="literal">pgpsigurlmangle</code> comme expliqué dans <span class="citerefentry"><span class="refentrytitle">uscan</span>(1)</span>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="sourcef"/>5.23. <code class="filename">source/format</code></h2>
            </div>
          </div>
        </div>
        <p>
Dans le fichier <code class="filename">debian/source/format</code>, il devrait y
avoir une seule ligne indiquant le format voulu du paquet source (vérifier
en <span class="citerefentry"><span class="refentrytitle">dpkg-source</span>(1)</span> pour une liste exhaustive). Après
<code class="literal">Squeeze</code>, il devrait contenir selon les cas :
</p>
        <div class="itemizedlist">
          <ul class="itemizedlist">
            <li class="listitem">
              <p>
<code class="literal">3.0 (native)</code> pour les paquets Debian natifs ;
</p>
            </li>
            <li class="listitem">
              <p>
<code class="literal">3.0 (quilt)</code> pour tout le reste.
</p>
            </li>
          </ul>
        </div>
        <p>
Le récent format source <code class="literal">3.0 (quilt)</code> enregistre les
modifications dans un ensemble de correctifs <span class="command"><strong>quilt</strong></span> dans
<code class="filename">debian/patches</code>. Ces changements sont alors appliqués
automatiquement lors de l'extraction du paquet source. <a href="#ftn.idp39533584" class="footnote" id="idp39533584"><sup class="footnote">[60]</sup></a> Les modifications Debian sont simplement conservées
dans une archive <code class="filename">debian.tar.gz</code> contenant tous les
fichiers du répertoire <code class="filename">debian</code>. Ce nouveau format permet
d'inclure des fichiers binaires comme des icônes PNG sans
bidouillage. <a href="#ftn.idp39524944" class="footnote" id="idp39524944"><sup class="footnote">[61]</sup></a>
</p>
        <p>
Quand <span class="command"><strong>dpkg-source</strong></span> extrait un paquet source au format
<code class="literal">3.0 (quilt)</code>, il applique automatiquement tous les
correctifs énumérés dans <code class="filename">debian/patches/series</code>. Vous
pouvez éviter que les correctifs soient appliqués à la fin de l'extraction
avec l'option <code class="literal">--skip-patches</code>.
</p>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="sourcel"/>5.24. <code class="filename">source/local-options</code></h2>
            </div>
          </div>
        </div>
        <p>
Lors de la maintenance de paquet Debian avec un système de gestion de
version, il faut généralement créer une branche (par exemple
<code class="literal">upstream</code>) pour suivre les sources amont, et une autre
branche (typiquement <code class="literal">master</code> avec Git) pour suivre le
paquet Debian. Pour cette dernière, il est préférable de garder les sources
amont non modifiés aux côtés des fichiers <code class="filename">debian/*</code> du
paquet Debian pour faciliter la fusion avec les nouveaux sources d’amont.
</p>
        <p>
Après la construction d'un paquet, les sources sont normalement laissés
modifiés (« patched »). <code class="literal">dquilt pop -a</code> doit être exécuté
avant d'envoyer vers la branche <code class="literal">master</code>. Créer un fichier
optionnel <code class="filename">debian/source/local-options</code> contenant
<code class="literal">unapply-patches</code> permet d'automatiser cela. Ce fichier
n'est pas inclus dans le paquet source créé et modifie seulement le
comportement de construction local. Ce fichier peut aussi contenir
<code class="literal">abort-on-upstream-changes</code> (consultez <span class="citerefentry"><span class="refentrytitle">dpkg-source</span>(1)</span>).
</p>
        <pre class="screen">
unapply-patches
abort-on-upstream-changes
</pre>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="sourceopt"/>5.25. <code class="filename">source/options</code></h2>
            </div>
          </div>
        </div>
        <p>
Les fichiers créés automatiquement dans l'arborescence source peuvent être
assez agaçants pour l'empaquetage puisqu'ils sont à l'origine de grands
fichiers de correctif sans signification. Des modules personnalisés comme
<span class="command"><strong>dh_autoreconf</strong></span> permettent d'atténuer ce problème comme
décrit en <a class="xref" href="dreq.fr.html#customrules" title="4.4.3. Personnalisation du fichier rules">Section 4.4.3, « Personnalisation du fichier <code class="filename">rules</code> »</a>.
</p>
        <p>
Vous pouvez fournir une expression rationnelle Perl en argument de l'option
<code class="literal">--extend-diff-ignore</code> de <span class="citerefentry"><span class="refentrytitle">dpkg-source</span>(1)</span> pour ignorer les modifications faites aux fichiers créés
automatiquement lors de la création du paquet source.
</p>
        <p>
Comme solution générique pour aborder ce problème de fichiers créés
automatiquement, vous pouvez enregistrer ces arguments d'option de
<span class="command"><strong>dpkg-source</strong></span> dans le fichier
<code class="filename">source/options</code> du paquet source. L'exemple suivant
permet de sauter la création de fichiers de correctif pour
<code class="filename">config.sub</code>, <code class="filename">config.guess</code> et
<code class="filename">Makefile</code> :
</p>
        <pre class="screen">
extend-diff-ignore = "(^|/)(config\.sub|config\.guess|Makefile)$"
</pre>
      </div>
      <div class="section">
        <div class="titlepage">
          <div>
            <div>
              <h2 class="title"><a id="patches"/>5.26. <code class="filename">patches/*</code></h2>
            </div>
          </div>
        </div>
        <p>
L'ancien format source <code class="literal">1.0</code> créait un unique et gros
fichier <code class="filename">diff.gz</code> contenant les fichiers de maintenance
du paquet dans <code class="filename">debian</code> et les correctifs aux sources. Un
tel paquet est un peu délicat à inspecter et à comprendre pour chaque
modification de l'arbre source par la suite. Ce n'est pas conseillé.
</p>
        <p>
Le nouveau format source <code class="literal">3.0 (quilt)</code> conserve les
correctifs dans les fichiers <code class="filename">debian/patches/*</code> en
utilisant la commande <span class="command"><strong>quilt</strong></span>. Ces correctifs et les autres
données de paquet qui sont toutes contenues dans le répertoire
<code class="filename">debian</code> sont empaquetés dans le fichier
<code class="filename">debian.tar.gz</code>. Puisque la commande
<span class="command"><strong>dpkg-source</strong></span> peut gérer les correctifs au format
<span class="command"><strong>quilt</strong></span> des sources <code class="literal">3.0 (quilt)</code> sans le
paquet <code class="systemitem">quilt</code>, il n'est pas
nécessaire d'ajouter <code class="systemitem">quilt</code> en
<code class="literal">Build-Depends</code>. <a href="#ftn.idp39567456" class="footnote" id="idp39567456"><sup class="footnote">[62]</sup></a>
</p>
        <p>
La commande <span class="command"><strong>quilt</strong></span> est expliquée en <span class="citerefentry"><span class="refentrytitle">quilt</span>(1)</span>. Elle enregistre les modifications des sources comme une
pile de fichiers correctifs <code class="literal">-p1</code> dans le répertoire
<code class="filename">debian/patches</code> et l'arborescence source n'est pas
modifiée en dehors du répertoire <code class="filename">debian</code>. L'ordre
d'application de ces correctifs est enregistré dans le fichier
<code class="filename">debian/patches/series</code>. Vous pouvez appliquer
(« <code class="literal">push</code> »), enlever (« <code class="literal">pop</code> »), et
rafraîchir (« <code class="literal">refresh</code> ») les correctifs
facilement. <a href="#ftn.idp39576400" class="footnote" id="idp39576400"><sup class="footnote">[63]</sup></a>
</p>
        <p>
En <a class="xref" href="modify.fr.html" title="Chapitre 3. Modification du code source">Chapitre 3, <em>Modification du code source</em></a>, trois correctifs ont été créés dans
<code class="filename">debian/patches</code>.
</p>
        <p>
Puisque les correctifs Debian sont localisés en
<code class="filename">debian/patches</code>, veuillez vous assurer d'avoir configuré
correctement la commande <span class="command"><strong>dquilt</strong></span> conformément à la
description en <a class="xref" href="modify.fr.html#quiltrc" title="3.1. Configuration de quilt">Section 3.1, « Configuration de <span class="command"><strong>quilt</strong></span> »</a>.
</p>
        <p>
Quand quelqu'un (éventuellement vous-même) fournit un correctif
<code class="filename"><em class="replaceable"><code>toto</code></em>.patch</code> par la suite, la
modification d'un paquet source <code class="literal">3.0 (quilt)</code> est assez
simple :
</p>
        <pre class="screen">
$ dpkg-source -x gentoo_0.9.12.dsc
$ cd gentoo-0.9.12
$ dquilt import ../<em class="replaceable"><code>toto</code></em>.patch
$ dquilt push
$ dquilt refresh
$ dquilt header -e
... description du correctif
</pre>
        <p>
Les correctifs conservés au nouveau format source
<code class="literal">3.0 (quilt)</code> doivent être sans approximation
(« <span class="emphasis"><em>fuzz</em></span> »). Vous pouvez vous en assurer avec
<code class="literal">dquilt pop -a; while dquilt push; do dquilt refresh;
done</code>.
</p>
      </div>
      <div class="footnotes">
        <br/>
        <hr/>
        <div id="ftn.idp39241648" class="footnote">
          <p><a href="#idp39241648" class="para"><sup class="para">[54] </sup></a>
Dans ce chapitre, <code class="filename">debian/</code> est omis pour simplifier
l'écriture des fichiers du répertoire <code class="filename">debian</code> quand la
signification n'est pas ambiguë.
</p>
        </div>
        <div id="ftn.idp39269840" class="footnote">
          <p><a href="#idp39269840" class="para"><sup class="para">[55] </sup></a>Consultez <span class="citerefentry"><span class="refentrytitle">dpkg</span>(1)</span> et la <a class="ulink" href="http://www.debian.org/doc/debian-policy/ap-pkg-controlfields.html#s-pkg-f-Conffiles">Charte Debian, D.2.5 « Conffiles »</a>.
</p>
        </div>
        <div id="ftn.idp39357968" class="footnote">
          <p><a href="#idp39357968" class="para"><sup class="para">[56] </sup></a> Cela remplace la commande obsolète <span class="citerefentry"><span class="refentrytitle">dh_movefiles</span>(1)</span> configurée par le fichier <code class="filename">files</code>.  </p>
        </div>
        <div id="ftn.idp39425664" class="footnote">
          <p><a href="#idp39425664" class="para"><sup class="para">[57] </sup></a> Remarquez que la page de manuel initiale créée par
<span class="command"><strong>help2man</strong></span> prétendra que des renseignements supplémentaires
sont disponibles dans le système d'information. Si la commande n'a pas non
plus de page <span class="command"><strong>info</strong></span>, vous devriez modifier manuellement la
page créée par la commande <span class="command"><strong>help2man</strong></span>.  </p>
        </div>
        <div id="ftn.idp39463984" class="footnote">
          <p><a href="#idp39463984" class="para"><sup class="para">[58] </sup></a> La liste actuelle des sections est dans la <a class="ulink" href="http://www.debian.org/doc/packaging-manuals/menu-policy/ch2.html#s2.1">sous-charte de menu Debian 2.1 « structure de menu
conseillée »</a>. Une réorganisation majeure de la structure du menu a
été réalisée pour <code class="literal">Squeeze</code>.
</p>
        </div>
        <div id="ftn.idp39481568" class="footnote">
          <p><a href="#idp39481568" class="para"><sup class="para">[59] </sup></a> Malgré l'utilisation de raccourcis <span class="command"><strong>bash</strong></span> pour présenter
les noms des fichiers <code class="filename">{pre,post}{inst,rm}</code>, vous devriez
utiliser une syntaxe pure POSIX pour les scripts du responsable pour être
compatibles avec <span class="command"><strong>dash</strong></span> comme interpréteur de commande du
système.  </p>
        </div>
        <div id="ftn.idp39533584" class="footnote">
          <p><a href="#idp39533584" class="para"><sup class="para">[60] </sup></a> Consulter <a class="ulink" href="http://wiki.debian.org/Projects/DebSrc3.0">DebSrc3.0</a> pour un résumé de la
conversion des sources aux formats source <code class="literal">3.0 (quilt)</code> et
<code class="literal">3.0 (native)</code>.  </p>
        </div>
        <div id="ftn.idp39524944" class="footnote">
          <p><a href="#idp39524944" class="para"><sup class="para">[61] </sup></a>En fait, ce nouveau format permet de gérer des archives amont multiples et
plusieurs méthodes de compression. Ces considérations sortent du cadre de ce
document.</p>
        </div>
        <div id="ftn.idp39567456" class="footnote">
          <p><a href="#idp39567456" class="para"><sup class="para">[62] </sup></a> Plusieurs méthodes de maintenance des ensembles de correctifs ont été
proposés et sont utilisés dans les paquets Debian. Le système
<span class="command"><strong>quilt</strong></span> est le système de maintenance conseillé. Parmi
d'autres, <span class="command"><strong>dpatch</strong></span>, <span class="command"><strong>dbs</strong></span> et
<span class="command"><strong>cdbs</strong></span> existent. La plupart d'entre eux conservent aussi
les correctifs dans des fichiers <code class="filename">debian/patches/*</code>.  </p>
        </div>
        <div id="ftn.idp39576400" class="footnote">
          <p><a href="#idp39576400" class="para"><sup class="para">[63] </sup></a> Si vous demandez à un parrain d'envoyer le paquet, cette sorte de séparation
claire et documentation de vos modifications est très importante pour
accélérer l'examen du paquet.  </p>
        </div>
      </div>
    </div>
    <div class="navfooter">
      <hr/>
      <table width="100%" summary="Navigation footer">
        <tr>
          <td align="left"><a accesskey="p" href="dreq.fr.html"><img src="images/prev.png" alt="Précédent"/></a> </td>
          <td align="center"> </td>
          <td align="right"> <a accesskey="n" href="build.fr.html"><img src="images/next.png" alt="Suivant"/></a></td>
        </tr>
        <tr>
          <td align="left" valign="top">Chapitre 4. Fichiers nécessaires dans le répertoire <code class="filename">debian</code> </td>
          <td align="center">
            <a accesskey="h" href="index.fr.html">
              <img src="images/home.png" alt="Sommaire"/>
            </a>
          </td>
          <td align="right" valign="top"> Chapitre 6. Construction du paquet</td>
        </tr>
      </table>
    </div>
  </body>
</html>
